/* This file was generated by GiottoC: http://www.eecs.berkeley.edu/~fresco/giotto */

#include "f_table.h" 

c_bool key_sensor;
void driver_key_sensor_c_connect_sensor_to_return_key () {
  c_connect_sensor_to_return_key(&key_sensor);
}

c_int random_sensor;
void driver_random_sensor_c_connect_sensor_to_random_generator () {
  c_connect_sensor_to_random_generator(&random_sensor);
}

c_string display_actuator;
void driver_display_actuator_c_connect_actuator_to_display () {
  c_connect_actuator_to_display(&display_actuator);
}

c_string global_control_output;
c_string local_control_output;

void driver_control_output_init_c_empty_string () {
  c_empty_string(&global_control_output);
  c_empty_string(&local_control_output);
}

void driver_control_output_copy_c_string () {
  copy_c_string(&local_control_output, &global_control_output);
}

c_int global_navigation_output;
c_int local_navigation_output;

void driver_navigation_output_init_c_one () {
  c_one(&global_navigation_output);
  c_one(&local_navigation_output);
}

void driver_navigation_output_copy_c_int () {
  copy_c_int(&local_navigation_output, &global_navigation_output);
}

c_int control_control_input;
#ifdef OSEK
TASK(task_control) {
#else
void task_control () {
#endif
  c_control_task(&control_control_input, &local_control_output);
#ifdef OSEK
  e_machine_go();
#endif
}

c_int navigation_sensor_input;
c_int navigation_navigation_state;

void driver_navigation_navigation_state_init_c_one () {
  c_one(&navigation_navigation_state);
}

#ifdef OSEK
TASK(task_navigation) {
#else
void task_navigation () {
#endif
  c_navigation_task(&navigation_sensor_input, &navigation_navigation_state, &local_navigation_output);
#ifdef OSEK
  e_machine_go();
#endif
}

unsigned condition_display_actuator_display_driver () {
  return c_true();
}

void driver_display_actuator_display_driver () {
  c_string_to_string(&global_control_output, &display_actuator);
}

unsigned condition_degraded_key_pressed () {
  return c_key_pressed(&key_sensor);
}

void driver_degraded_key_pressed () {
  c_switch_mode(&global_navigation_output);
}

unsigned condition_control_control_driver () {
  return c_true();
}

void driver_control_control_driver () {
  c_int_to_int(&global_navigation_output, &control_control_input);
}

unsigned condition_navigation_navigation_driver () {
  return c_true();
}

void driver_navigation_navigation_driver () {
  c_int_to_int(&random_sensor, &navigation_sensor_input);
}

unsigned condition_normal_key_pressed () {
  return c_key_pressed(&key_sensor);
}

void driver_normal_key_pressed () {
  c_switch_mode(&global_navigation_output);
}

trigger_type trigger_table[MAXTRIGGER] = {
  { "giotto_timer", giotto_timer_enable_code, giotto_timer_save_code, giotto_timer_trigger_code }
};

task_type task_table[MAXTASK] = {
  { "control", task_control },
  { "navigation", task_navigation }
};

driver_type driver_table[MAXDRIVER] = {
  { "key_sensor_c_connect_sensor_to_return_key", driver_key_sensor_c_connect_sensor_to_return_key, 0 },
  { "random_sensor_c_connect_sensor_to_random_generator", driver_random_sensor_c_connect_sensor_to_random_generator, 0 },
  { "display_actuator_c_connect_actuator_to_display", driver_display_actuator_c_connect_actuator_to_display, 0 },
  { "control_output_init_c_empty_string", driver_control_output_init_c_empty_string, 1 },
  { "control_output_copy_c_string", driver_control_output_copy_c_string, 1 },
  { "navigation_output_init_c_one", driver_navigation_output_init_c_one, 2 },
  { "navigation_output_copy_c_int", driver_navigation_output_copy_c_int, 2 },
  { "navigation_navigation_state_init_c_one", driver_navigation_navigation_state_init_c_one, 2 },
  { "display_actuator_display_driver", driver_display_actuator_display_driver, 0 },
  { "degraded_key_pressed", driver_degraded_key_pressed, 0 },
  { "control_control_driver", driver_control_control_driver, 1 },
  { "navigation_navigation_driver", driver_navigation_navigation_driver, 2 },
  { "normal_key_pressed", driver_normal_key_pressed, 0 }
};

condition_type condition_table[MAXCONDITION] = {
  { "display_actuator_display_driver", condition_display_actuator_display_driver, 0 },
  { "degraded_key_pressed", condition_degraded_key_pressed, 0 },
  { "control_control_driver", condition_control_control_driver, 0 },
  { "navigation_navigation_driver", condition_navigation_navigation_driver, 0 },
  { "normal_key_pressed", condition_normal_key_pressed, 0 }
};

port_type port_table[MAXPORT] = {
  { "key_sensor", &key_sensor, sizeof(c_bool) },
  { "random_sensor", &random_sensor, sizeof(c_int) },
  { "display_actuator", &display_actuator, sizeof(c_string) },
  { "global_control_output", &global_control_output, sizeof(c_string) },
  { "local_control_output", &local_control_output, sizeof(c_string) },
  { "global_navigation_output", &global_navigation_output, sizeof(c_int) },
  { "local_navigation_output", &local_navigation_output, sizeof(c_int) },
  { "control_control_input", &control_control_input, sizeof(c_int) },
  { "navigation_sensor_input", &navigation_sensor_input, sizeof(c_int) },
  { "navigation_navigation_state", &navigation_navigation_state, sizeof(c_int) }
};

